<?php
/* 
   MasterSoft Software Solutions Ltd. - www.mastersoft.at - October. 2009 
   info@mastersoft.at
   This file is licensed under terms of the MPT Open License.
   You can find the license under http://www.mastersoft.at/content/view/26/34/lang,de/    
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');


/**
 * @author <a href="http://www.mastersoft.at" target="_blank">MasterSoft Software Solutions Ltd.</a>
 *
 */
class VideosControllerUploadFiles extends VideosController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
			
		$this->registerTask( 'uploadFlv','uploadFlv');	
		$this->registerTask( 'uploadMov','uploadMov');
		$this->registerTask( 'uploadThumb','uploadThumb');			
		$this->registerTask( 'deleteFlashFiles','deleteFlashFiles');
		$this->registerTask( 'deleteMovFiles','deleteMovFiles');
		$this->registerTask( 'deleteThumbFiles','deleteThumbFiles');			
		$this->registerTask( 'goBack','goBack');
		$this->registerTask( 'refreshDisk','refreshDisk');					
	}
	
	
	/**
	 * upload a flas file
	 * @return void
	 */
	function uploadFlv()
	{
		//create paths if not exist
		$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft";
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);
		
		$diskPath .= DS. "flash" ;	
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);
								
		if ( ($_FILES["file"]["type"] == "application/octet-stream")	||
		   ($_FILES["file"]["type"] == "application/x-shockwave-flash")	||
		   ($_FILES["file"]["type"] == "video/x-flv")	)		   
		{
	   		if ($_FILES["file"]["error"] > 0)
    		{
    			JError::raiseWarning( 500, 'An error occured' );
    		}
    		else
    		{
    			$fileName = $_FILES["file"]["name"];
    			$ext = JFile::getExt($fileName);    			
    			    			    			 
    			if($ext != "flv" && $ext != "f4v")
    			{    				
    				JError::raiseWarning( 500, 'Wrong file type' );
    			}
    			else
    			{
    				$src = $_FILES["file"]["tmp_name"];
    				$dst = $diskPath .DS .$fileName;
    				$fileName = $_FILES["file"]["name"];    				
    				$url = JURI::root() . "media/mastersoft/flash/" . $fileName;
    				
    				if(JFile::upload($src,$dst))
    				{    					
    					$model = $this->getModel('uploadfiles');	 					
    					$msg = $model->storeFileInDB($fileName,$dst,"flash",$url);					
    				}
    				else
    					JError::raiseWarning( 500, 'Error while uploading file' );
    			}
    		}
		}
		else
		{			
			JError::raiseWarning( 500, 'Wrong file type' );
		}
		
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer&task=uploadfiles', $msg );
				
		parent::display();
	}
	
	
	/**
	 * upload a quicktime file
	 * @return void
	 */
	function uploadMov()
	{
		//create paths if not exist
		$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft";
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);
		
		$diskPath .= DS. "quicktime" ;	
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);
			
			
		if ($_FILES["file"]["type"] == "application/octet-stream")		   
		{
	   		if ($_FILES["file"]["error"] > 0)
    		{
    			JError::raiseWarning( 500, 'An error occured' );
    		}
    		else
    		{
    			$fileName = $_FILES["file"]["name"];
    			$ext = JFile::getExt($fileName);    			
    			    			    			 
    			if($ext != "mov" || $ext != "mp4")
    			{    				
    				JError::raiseWarning( 500, 'Wrong file type' );
    			}
    			else
    			{
    				$src = $_FILES["file"]["tmp_name"];
    				$dst = $diskPath .DS .$fileName;
    				$url = JURI::root() . "media/mastersoft/quicktime/" . $fileName;
    				
    				if(JFile::upload($src,$dst))
    				{
    					$model = $this->getModel('uploadfiles');	 					
    					$msg = $model->storeFileInDB($fileName,$dst,"mov",$url);
    				}
    				else
    					JError::raiseWarning( 500, 'Error while uploading file' );
    			}
    		}
		}
		else
		{			
			JError::raiseWarning( 500, 'Wrong file type' );
		}
		
		
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer&task=uploadfiles', $msg );
				
		parent::display();
	}
	
	
	/**
	 * upload thumb file
	 * @return void
	 */
	function uploadThumb()
	{
		//create paths if not exist
		$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft";
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);
		
		$diskPath .= DS. "thumbs" ;	
		
		if(!JFolder::exists($diskPath))			
			JFolder::create($diskPath);								
				
		
		if (   ($_FILES["file"]["type"] == "image/gif")
			|| ($_FILES["file"]["type"] == "image/jpg")
			|| ($_FILES["file"]["type"] == "image/jpeg")
			|| ($_FILES["file"]["type"] == "image/png")
			&& ($_FILES["file"]["size"] < 4194304) )	   
		{
	   		if ($_FILES["file"]["error"] > 0)
    		{
    			JError::raiseWarning( 500, 'An error occured' );
    		}
    		else
    		{
    			$fileName = $_FILES["file"]["name"];
    			$ext = strtolower(JFile::getExt($fileName));    			
    			
    			if($ext != "gif" && $ext != "jpg" && $ext != "jpeg" && $ext != "png")
    			{    				
    				JError::raiseWarning( 500, 'Wrong file type' );
    			}
    			else
    			{
    				
    				$src = $_FILES["file"]["tmp_name"];
    				$dst = $diskPath .DS .$fileName;
    				$url = JURI::root() . "media/mastersoft/thumbs/" . $fileName;
    				
    				//check size
    				$imageAttr = getimagesize(src);
    				
    				if($imageAttr[0] < 150 && $imageAttr[1] < 75 )
    				{    					    				
    					if(JFile::upload($src,$dst))
    					{
    						$model = $this->getModel('uploadfiles');	 					
    						$msg = $model->storeFileInDB($fileName,$dst,"thumb",$url);    						
    					}
    					else
    						JError::raiseWarning( 500, 'Error while uploading file' );
    				}
    				else
    				{
    					JError::raiseWarning( 500, 'Error while uploading file. Dimesions are too large!' );
    				}
    			}
    		}
		}
		else
		{			
			JError::raiseWarning( 500, 'Wrong file type' );
		}
		
		
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer&task=uploadfiles', $msg );
				
		parent::display();
	}
	
	
	/**
	 * delete selected flash files
	 * @return void
	 */
	function deleteFlashFiles()
	{
		$model = $this->getModel('uploadfiles');				
		$fileNames = $_REQUEST['deleteFormFiles'];
			
		if($fileNames != "")
		{	
			$fileNames = explode(';',$fileNames);
			$model->deleteFiles($fileNames,"flash");
		}
		
		JRequest::setVar( 'view', 'uploadfiles' );		
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	
	/**
	 * delete selected quicktime files
	 * @return void
	 */
	function deleteMovFiles()
	{
		$model = $this->getModel('uploadfiles');				
		$fileNames = $_REQUEST['deleteFormFiles'];
			
		if($fileNames != "")
		{	
			$fileNames = explode(';',$fileNames);
			$model->deleteFiles($fileNames,"mov");
		}
		
		JRequest::setVar( 'view', 'uploadfiles' );		
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	
	/**
	 * delete selected thumb files
	 * @return void
	 */
	function deleteThumbFiles()
	{
		$model = $this->getModel('uploadfiles');				
		$fileNames = $_REQUEST['deleteFormFiles'];
			
		if($fileNames != "")
		{	
			$fileNames = explode(';',$fileNames);
			$model->deleteFiles($fileNames,"thumb");
		}
		
		JRequest::setVar( 'view', 'uploadfiles' );		
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	
	/**
	 * cancel the upload files view
	 * @return void
	 */
	function goBack()
	{				
		$this->setRedirect( 'index.php?option=com_masterSoftVideoPlayer', $msg );
	}

	
	/**
	 * refresh files from disk
	 * @return void
	 */
	function refreshDisk()
	{
		$model = $this->getModel('uploadfiles');
		$model->refreshDisk();
		
		JRequest::setVar( 'view', 'uploadfiles' );		
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
}
?>
